#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>

#define MAXDIM 10
typedef int MATRICA[MAXDIM][MAXDIM];

//void prikazMatrice(int matrica[][3], int brojRedova, int brojKolona);
void prikazMatrice(MATRICA matrica, int brojRedova, int brojKolona);
void unosMatrice(MATRICA matrica, int *n, int *m);
void prikaziIndeksKoloneSaNajvecomSumom(MATRICA matrica, int n, int m);
void prikaziIndeksKoloneSaNajvecomSumomBeta(MATRICA matrica, int n, int m);
int sumaDateKoloneMatrice(MATRICA matrica, int n, int zadataKolona);
void prikazGlavneDijagonale(MATRICA matrica, int n);

int main(void) {
	//int matrica[10][10];
	/*
	int matrica[][3] = {
		{3,2,1},
		{4,3,2},
		{5,4,3},
		{6,5,4}};
	int n = 4;
	int m = 3;
	*/
	/*int matrica[10][10] = { 
		{3,2,1},
		{4,3,2},
		{5,4,3},
		{6,5,4}};
	int n = 4;
	int m = 3;
	*/
	
	MATRICA matrica = {
		{3,2,1,5},
		{4,3,2,4},
		{5,4,3,3},
		{6,5,4,2} };
	int n = 4;
	int m = 4;
	/*
	MATRICA matrica;
	int n, m;
	*/
	//unosMatrice(matrica, &n, &m);
	prikazMatrice(matrica, n, m);
	prikaziIndeksKoloneSaNajvecomSumom(matrica, n, m);
	printf("Prikaz elemenata glavne dijagonale\n");
	prikazGlavneDijagonale(matrica, n);


	system("pause");
	return 0;
}

void prikazMatrice(MATRICA matrica, int brojRedova, int brojKolona) {
	int i, j;
	printf("Elementi matrice su:\n");
	for (i = 0; i < brojRedova; i++) {
		for (j = 0; j < brojKolona; j++) {
			printf("%d\t", matrica[i][j]);
		}
		printf("\n");
	}
}

void unosMatrice(MATRICA matrica, int *n, int *m) {
	printf("Unesite dimenzije matrice:\n");
	scanf("%d %d", n, m);
	int i, j;
	int element;
	for (i = 0; i < *n; i++) {
		for (j = 0; j < *m; j++) {
			printf("Unesite element na poziciji[%d][%d]", i, j);
			scanf("%d", &element);
			matrica[i][j] = element;
		}
	}
}

int sumaDateKoloneMatrice(MATRICA matrica, int n, int zadataKolona) {
	int suma = 0;
	int i;
	for (i = 0; i < n; i++) {
		suma += matrica[i][zadataKolona];
	}
	return suma;
}

void prikaziIndeksKoloneSaNajvecomSumom(MATRICA matrica, int n, int m) {
	int suma = 0;
	int maxSuma;
	int maxIndex = 0;
	int i, j;
	for (i = 0; i < n; i++) {
		suma += matrica[i][0];
	}
	maxSuma = suma;
	for (j = 1; j < m; j++) {
		suma = 0;
		for (i = 0; i < n; i++) {
			suma += matrica[i][j];
		}
		if (suma > maxSuma) {
			maxSuma = suma;
			maxIndex = j;
		}
	}
	printf("Kolona sa najvecom sumom je %d. kolona\n", maxIndex + 1);
}

void prikazGlavneDijagonale(MATRICA matrica, int n) {
	int i;
	for (i = 0; i < n; i++) {
		printf("%d\n", matrica[i][i]);
	}
	printf("\n");
}

void prikazSporedneDijagonale(MATRICA matrica, int n) {
	int i;
	for (i = 0; i < n; i++) {
		printf("%d\n", matrica[i][n - 1 - i]);
	}
	printf("\n");
}

void prikaziIndeksKoloneSaNajvecomSumomBeta(MATRICA matrica, int n, int m) {
	int suma = 0;
	int maxSuma = sumaDateKoloneMatrice(matrica, n, 0);
	int maxIndex = 0;
	int j;
	for (j = 1; j < m; j++) {
		suma = sumaDateKoloneMatrice(matrica, n, j);
		if (suma > maxSuma) {
			maxSuma = suma;
			maxIndex = j;
		}
	}
	printf("Kolona sa najvecom sumom je %d. kolona\n", maxIndex + 1);
}